/*
 * usb-adafruit-cdc.c
 *
 * Created: 5/3/2018 6:39:05 PM
 * Author : Jake
 */ 

#include <stdio.h>
#include "sam.h"
#include "sam_ba_usb.h"
#include "sam_ba_monitor.h"

static volatile bool main_b_cdc_enable = false;

int main(void)
{
    /* Initialize the SAM system */
    SystemInit();
	
	// clock setup to run main CPU at 120MHz, and DFLL48M setup from internal osc, should run USB
	board_init();
	// enable interrupts in the system
	__enable_irq();
	
	// turning a light on to see if we hang
	PORT->Group[1].DIRSET.reg = (uint32_t)(1 << 14);
	PORT->Group[0].DIRSET.reg = (uint32_t)(1 << 21);
	PORT->Group[0].OUTSET.reg = (uint32_t)(1 << 21);
	
	// pointer to the USB struct in sam_ba_usb.h
	P_USB_CDC pCdc; 
	
	// turn the USB on, sam_ba_usb.h and .c
	pCdc = usb_init();
	
	// a ticker to look for hangouts
	SysTick_Config(8000000);

    /* Replace with your application code */
    while (1) 
    {

		// waits for config to config
		if(pCdc->IsConfigured(pCdc) != 0){
			main_b_cdc_enable = true;
		}
		
		// if config is config, and port is opened
		if(main_b_cdc_enable){
			sam_ba_monitor_init(SAM_BA_INTERFACE_USBCDC);
			// loops on this
			while(1){
				sam_ba_monitor_run();
				// @ HERE: understand how this /\ runs, looks through buffer etc... do the same for (1) bytes -> uart
				// (2) for packet searching
				PORT->Group[0].OUTCLR.reg = (uint32_t)(1 << 21);
			}
		}
		
		// do_something
		// monitor_run
	}
}

void SysTick_Handler(void){
	PORT->Group[1].OUTTGL.reg = (uint32_t)(1 << 14);
	//PORT->Group[0].OUTTGL.reg = (uint32_t)(1 << 21);
	// monitor_sys_tick
}
